#if !defined( __DESC_H__ )
#define __DESC_H__

#include <windows.h>

#define MAX_DESC MAX_PATH

//////////////////////////////////////////////////////////////////////////////
//   File description structure

struct DESC
{
     TCHAR lpszFileName[MAX_PATH]; // filename
     TCHAR lpszDesc[MAX_DESC];     // file description
};

//   Reads line
//
BOOL ReadLine(
     HANDLE hFile,            // handle to file to be read
     TCHAR lpBuffer[],        // buffer, where line will be stored
     DWORD dwBuffer );        // buffer size

//   Extracts filename and file description from description
//
BOOL ExpandDescFile(
     LPCTSTR lpcszSrc,        // description line
     LPTSTR lpszFileName,     // filename buffer
     LPTSTR lpszDesc );       // description buffer

//   Loads description files list
//
BOOL LoadDescFile(
     LPCTSTR lpcszFileName,   // description files list filename
     DESC lpDesc[],           // description array
     DWORD dwDesc,            // description array size
     DWORD *lpcItems );       // pointer to dword, where items read will be write

//   Writes description files list
//
BOOL SaveDescFile(
     LPCTSTR lpcszFileName,   // description files list filename
     DESC lpDesc[],           // description array
     DWORD dwDesc );          // number of items to save

//   Finds file description
//
BOOL FindDesc(
     LPCTSTR lpcszFileName,   // filename being find
     DESC lpDesc[],           // description array
     DWORD dwDesc,            // description array size
     DWORD *lpdwFound );      // index of found element

//   Adds file description to array
//
BOOL AddDesc(
     DESC lpDesc[],           // description array
     DWORD dwDesc,            // description array size
     LPCTSTR lpcszFileName,   // filename
     LPCTSTR lpcszDesc,       // description
     DWORD dwIndex );         // array index

#endif
