// AutoBuf.h: interface for the CAutoBuf class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_AUTOBUF_H__6064D759_C415_48F3_9B27_E93214A7EF5B__INCLUDED_)
#define AFX_AUTOBUF_H__6064D759_C415_48F3_9B27_E93214A7EF5B__INCLUDED_

#pragma once
#pragma warning(disable: 4290)

#include "common.h"

class CAutoBufChar  
{
	typedef char T;
	typedef char* PT;

	PT m_buf;
	DWORD m_Size;
	
	friend void swap(CAutoBufChar &a1, CAutoBufChar &a2)\
	{
		PT pbuf = a1.m_buf;
		DWORD size= a1.m_Size;
		a1.m_buf = a2.m_buf;
		a1.m_Size = a2.m_Size;
		a2.m_buf = pbuf;
		a2.m_Size = size;
	}
	void operator=(char* ){}
public:
	CAutoBufChar() : m_buf(NULL), m_Size(0) {};
	CAutoBufChar(char const* pstr) throw (terrors_t) : m_buf(NULL), m_Size(0) 
	{
		Assign(pstr);
	}
	~CAutoBufChar() 
	{
		if (GetSize())	alloc_free(m_buf);
	}

	DWORD GetSize() const { return m_Size;}
	operator PT() {return m_buf;};
	PT operator&() {return &m_buf[0];}

//   
	void Alloc(DWORD Size) throw (terrors_t)
	{
		if (! Size) return;
		if (Size < m_Size) return;	//   

		if (m_buf) alloc_free(m_buf);
		m_buf = reinterpret_cast<PT>(alloc_malloc(sizeof(T) * Size));
		m_Size = (NULL == m_buf) ? 0 : Size;
		if (NULL == m_buf) throw ERROR_BAD_ALLOC;
	}
	void Assign(char const* pstr) throw (terrors_t)
	{
		DWORD len = ::lstrlen(pstr) + 1;
		if (m_Size < len) Alloc(len);
		::lstrcpy(m_buf, pstr);
	}

//    
	CAutoBufChar& operator += (const T* p) throw(terrors_t)
	{
		DWORD len = ::lstrlen(m_buf) + ::lstrlen(p) + 1;
		if (m_Size < len)
		{
			CAutoBufChar buf;
			buf.Alloc(len);
			buf.Assign(m_buf);
			swap(*this, buf);
		} 
		::lstrcat(m_buf, p);
		return *this;
	}

	T* TakePossession()
	{
		PT p = m_buf;
		m_buf = NULL;
		m_Size = 0;
		return p;	// p    
	}
};

#endif // !defined(AFX_AUTOBUF_H__6064D759_C415_48F3_9B27_E93214A7EF5B__INCLUDED_)
