#include "stdafx.h"
#include "common.h"
#include "registry.h"
#include "nflang.h"

extern CAutoBufChar g_Prefix;

extern void SET_FAR_DIALOG_ITEM(FarDialogItem &item, int Type, 
								int x1, int y1, int x2, int y2,
								int Focus, char* History, DWORD Flags,
								int DefButtons, char const *p);

void SET_FAR_DIALOG_CHECKBOX_ITEM(FarDialogItem &item, 
						 int x1, int y1, int Focus,
						 int Selected,
						 DWORD Flags,
						 int DefButtons,
						 char const *p)
{
	item.Type = DI_CHECKBOX;
	item.X1 = x1;
	item.Y1 = y1;
	item.X2 = 0;
	item.Y2 = 0;
	item.Focus = Focus;
	item.Selected = Selected;
	item.Flags = Flags;
	item.DefaultButton = DefButtons;
	lstrcpy(item.Data, p);
}

void SavePluginSettings() throw (DWORD)
{
	TRACE("SaveSettings");
	CRegistry reg(true);
	reg.SetValue(KEY_PREFIX, g_Prefix);	
	reg.SetValue(KEY_SHOWERRORS, g_ShowErrors);	
	reg.SetValue(KEY_SHOWINPLUGINMENU, g_ShowInPluginMenu);	
	reg.SetValue(KEY_SHOWINDISKMENU, g_ShowInDiskMenu);	
	reg.SetValue(KEY_SHOWTEMPNAMESASHIDEFILES, g_ShowTemporaryNamesAsHideFiles);	
	reg.SetValue(KEY_USEHIGHLIGHT, g_UseHighlighting);	
	reg.SetValue(KEY_AUTOCOMPLITE, g_AutoComplite);	
}

int ConfiguratePlugin() throw (DWORD)
{	//  
	const int WIDTH = 52;
	const int HEIGHT = 14;
	const int NUM_ITEMS = 10;
	FarDialogItem Items[NUM_ITEMS];

	int ni = 0;						//    Items
	const int FX = 2, FY = 1;		//     
	const int GAPX = 4, GAPY = 2;	//    

	// 
		SET_FAR_DIALOG_ITEM(Items[ni++], DI_DOUBLEBOX, FX, FY, WIDTH-FX-1, HEIGHT-FY-1, 0, 0, 
			0, 0, GetMsg(LANG_CFG_TITLE));
		int nline = FY+1;		// ,     
	//    
		const int idINDISKMENU = ni;
		SET_FAR_DIALOG_CHECKBOX_ITEM(Items[ni++], GAPX+1, nline, 1,
			(g_ShowInDiskMenu) ? 1 : 0, 0, 0, GetMsg(LANG_CFG_SHOWINDISKMENU));
		nline += 1;
	//    
		const int idINPLUGINSMENU = ni;
		SET_FAR_DIALOG_CHECKBOX_ITEM(Items[ni++], GAPX+1, nline, 0,
			(g_ShowInPluginMenu) ? 1 : 0, 0, 0, GetMsg(LANG_CFG_SHOWINPLUGINSMENU));
	//     
		nline += 1;
		nline += 1;
		const int idTEMPASHIDDEN = ni;
		SET_FAR_DIALOG_CHECKBOX_ITEM(Items[ni++], GAPX+1, nline, 0,
			(g_ShowTemporaryNamesAsHideFiles) ? 1 : 0, 0, 0, GetMsg(LANG_CFG_HIDETEMPNAMES));
	// 
		nline += 1;
		const int idERRORS = ni;
		SET_FAR_DIALOG_CHECKBOX_ITEM(Items[ni++], GAPX+1, nline, 0,
			(g_ShowErrors) ? 1 : 0, 0, 0, GetMsg(LANG_CFG_SHOW_ERROR));
	// ,   
		nline += 1;
		const int idAUTOCOMPLITE= ni;
		SET_FAR_DIALOG_CHECKBOX_ITEM(Items[ni++], GAPX+1, nline, 0,
			(g_AutoComplite) ? 1 : 0, 0, 0, GetMsg(LANG_CFG_AUTOCOMPLITE));
		nline += 1;
		nline += 1;
	
	/*	//    
		const int idUSEHIGHLIGHT = ni;
		SET_FAR_DIALOG_CHECKBOX_ITEM(Items[ni++], GAPX+1, nline, 1,
			(g_UseHighlighting) ? 1 : 0, 0, 0, GetMsg(LANG_CFG_USEHIGHLIGHT));
	*/
	//
		SET_FAR_DIALOG_ITEM(Items[ni++], DI_TEXT, GAPX+1, nline, 0, 0,  0, NULL, 
			0, 0, GetMsg(LANG_CFG_PREFIX));
	// 
		const int idPREFIX = ni;
		SET_FAR_DIALOG_ITEM(Items[ni++], DI_EDIT, 14, nline, 19, 1, 1, NULL, 
			0, 0, g_Prefix);
		nline += 2;
	// OK & Cancel
		const int idOK = ni;
		SET_FAR_DIALOG_ITEM(Items[ni++], DI_BUTTON, 16, nline, 0, 0,  0, NULL, 
			0, 0, "&OK" );
		const int idCancel = ni;
		SET_FAR_DIALOG_ITEM(Items[ni++], DI_BUTTON, 24, nline, 0, 0,  0, NULL, 
			0, 0, "&Cancel");
	int nChoosenItem = g_PluginInfo.Dialog(
		g_PluginInfo.ModuleNumber, -1, -1, 
		WIDTH, HEIGHT, NULL, Items, NUM_ITEMS);
	if ((nChoosenItem == -1) || (nChoosenItem == idCancel))
		return FALSE;

	g_ShowErrors = Items[idERRORS].Selected;
	g_ShowInPluginMenu = Items[idINPLUGINSMENU].Selected;
	g_ShowInDiskMenu = Items[idINDISKMENU].Selected;
	g_ShowTemporaryNamesAsHideFiles = Items[idTEMPASHIDDEN].Selected;
//	g_UseHighlighting = Items[idUSEHIGHLIGHT].Selected;
	g_Prefix.Assign(static_cast<char*>(Items[idPREFIX].Data));
	g_AutoComplite = Items[idAUTOCOMPLITE].Selected;

	SavePluginSettings();
	return TRUE;
}
