// NamesPanel.h: interface for the CNamesPanel class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NAMESPANEL_H__62760875_6842_4B10_BDB6_86C197799790__INCLUDED_)
#define AFX_NAMESPANEL_H__62760875_6842_4B10_BDB6_86C197799790__INCLUDED_

#pragma once

#include "common.h"
#include "plugin.hpp"

/*	
	 ,    .
*/

class CNamesPanel  
{
	CAutoBufChar m_PanelTitle;			// 
	CAutoBufChar m_CurrentFilter;		//  
	CAutoBufChar **m_pFolders;			//  ,        
	PluginPanelItem *m_pPanelItems;		//    
	UINT m_NumPanelItems;				//  
	UINT m_AllocatedNumberItems;		//    ..
	
	terrors_t UpdateListItems();
	void AddItemsToList(const char *SubKey, bool bNonVolatile, 
		bool AsDirectory, char const* pExclude) throw (terrors_t);
	void DeleteListItems();
	bool IsNoFilter() {return ((char*)m_CurrentFilter)[0] == 0;}
	void FullUpdate();
	int EditDirectory(char const *Name, char const* Filter);
	void SetFilter(char const *sFilter);
public:
	CNamesPanel() throw (terrors_t);
	virtual ~CNamesPanel();

	void GetOpenPluginInfo(struct OpenPluginInfo *Info);
	int GetFindData(PluginPanelItem **pPanelItem, int *pItemsNumber, int OpMode);	
	int SetDirectory(const char *Dir, int OpMode);
	int SetDirectoryInOtherPanel(const char *Dir, int OpMode);
	int PutFiles(struct PluginPanelItem *PanelItem, int ItemsNumber, int Move, int OpMode);
	int ProcessKey(int Key, unsigned int ControlState);
	int MakeDirectory (char *Name, int OpMode);
public:
	void SetFilterAndUpdate(char const *sFilter) {SetFilter(sFilter); FullUpdate();}
};

#endif // !defined(AFX_NAMESPANEL_H__62760875_6842_4B10_BDB6_86C197799790__INCLUDED_)
