#include "stdafx.h"
#include "common.h"
#include "registry.h"

extern DWORD GetFolderAndType(char const* Name, CAutoBufChar &buf);

DWORD GetFolderAndTypeByIncompleteName(char const* Name, 
									   CAutoBufChar &buf)
{	
	/*
		   
		   -    
		 REG_SZ   .
	*/
	UINT NumberMatches = 0;			//  
	UINT ChoosedMatch = -1;			//    pMatches
	CAutoBufChar **pMatches = 0;	// 

	try {
		CAutoBufChar filter(Name);
		filter += "*";

		CRegistry r(REGISTRY_PLUGIN_NON_VOLATILE_LISTKEYS_SUBKEY, true, false);
		CRegistryEnum reg(r);
		while (reg.load_next_key(buf))
		{
			if (g_PluginInfo.CmpName(filter, buf, FALSE))
			{	//    Name -    
				NumberMatches++;
				pMatches = reinterpret_cast<CAutoBufChar**>(realloc(pMatches, 
					sizeof(CAutoBufChar*) * NumberMatches));
				pMatches[NumberMatches - 1] = new CAutoBufChar(static_cast<char*>(buf));
			}
		}
	} catch (...)
	{
		//error
	}
	if (NumberMatches == 0) return 0;

//   Name    -      
//   
	if (NumberMatches > 1)
	{
		const int size = sizeof(struct FarMenuItem)*NumberMatches;
		struct FarMenuItem* pMenuItems = reinterpret_cast<struct FarMenuItem*>(alloc_malloc(size));
		for (UINT i = 0; i < NumberMatches; ++i)
			lstrcpy(pMenuItems[i].Text, *pMatches[i]);
		ChoosedMatch = g_PluginInfo.Menu(g_PluginInfo.ModuleNumber, -1,-1,0,
			FMENU_AUTOHIGHLIGHT|FMENU_WRAPMODE, "", NULL, 
			"", NULL, NULL, pMenuItems, NumberMatches);
		delete pMenuItems;
	} else ChoosedMatch = 0;

	CAutoBufChar FullName;
	if (ChoosedMatch >= 0) 
		FullName.Assign(static_cast<char*>(*pMatches[ChoosedMatch]));

// 
	for (UINT i = 0; i < NumberMatches; ++i)
		delete pMatches[i];
	alloc_free(pMatches);

	return GetFolderAndType(FullName, buf);
}
