// common.cpp: implementation of the common class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "common.h"
#include "NFLang.h"

void* alloc_malloc(size_t size) {return HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, size);}//return malloc(size);}
void alloc_free(void* p) {::HeapFree(GetProcessHeap(), 0, p);} //{free(p);}

void *realloc(void* p, size_t size) 
{  
	if (p)
	{
		return::HeapReAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, p, size);
	}
	else
		return ::HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, size);
}

#ifdef __cplusplus
void * operator new(size_t size)
{
	return alloc_malloc(size);
}

void operator delete(void *p)
{
	alloc_free(p);
}
#endif


UINT pItems[NUM_ERRORS] = 
{
	0,
	LANG_ERROR_UNKNOWN_NAME,
	LANG_ERROR_REGISTRY_ACCESS,
	LANG_ERROR_BAD_ALLOC,
	LANG_ERROR_UNKNOWN_EXCEPTION
};

struct PluginStartupInfo g_PluginInfo; 
struct FarStandardFunctions g_FSF;


//registry keys
char const * REGISTRY_PLUGIN_DATA_KEY = "Software\\Far\\Plugins\\NamedFolders";
char const * REGISTRY_PLUGIN_NON_VOLATILE_LISTKEYS_SUBKEY = "\\Keys";
char const * REGISTRY_PLUGIN_VOLATILE_LISTKEYS_SUBKEY = "\\TempKeys";
char const * REGISTRY_PLUGIN_FILTERS_SUBKEY = "\\Filters";

//registry values
char const * KEY_PREFIX = "Prefix";
char const * KEY_SHOWERRORS = "ShowErrors";
char const * KEY_SHOWINPLUGINMENU = "ShowInPluginsMenu";
char const * KEY_SHOWINDISKMENU = "ShowInDiskMenu";
char const * KEY_SHOWTEMPNAMESASHIDEFILES = "ShowTemporaryNamesAsHideFiles";
char const * KEY_USEHIGHLIGHT = "UseHighlighting";
char const * KEY_AUTOCOMPLITE = "AutoComplite";

CAutoBufChar g_Prefix;
DWORD g_ShowErrors;				//   
DWORD g_ShowInPluginMenu;		//   
DWORD g_ShowInDiskMenu;			//   
DWORD g_ShowTemporaryNamesAsHideFiles;
DWORD g_UseHighlighting;		//   
DWORD g_AutoComplite;			//""    