// common.h: interface for the common class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMMON_H__5693E527_B98A_4F45_8134_2C926705181A__INCLUDED_)
#define AFX_COMMON_H__5693E527_B98A_4F45_8134_2C926705181A__INCLUDED_


#include "autobuf.h"

#pragma once

#define NUM_ERRORS 6
typedef enum terrors_t
{
	ERROR_NO				=	0,
	ERROR_UNKNOWN_NAME		=	1,
	ERROR_REGISTRY			=	2,
	ERROR_BAD_ALLOC			=	3,
	ERROR_UNKNOWN_EXCEPTION =	4,
	ERROR_WRONG_NAME_SYNTAX =	5
} _terrors_t;

extern UINT pItems[NUM_ERRORS];

extern char const * REGISTRY_PLUGIN_DATA_KEY;
extern char const * REGISTRY_PLUGIN_NON_VOLATILE_LISTKEYS_SUBKEY;
extern char const * REGISTRY_PLUGIN_VOLATILE_LISTKEYS_SUBKEY;
extern char const * REGISTRY_PLUGIN_FILTERS_SUBKEY;


extern char const * KEY_PREFIX;
extern char const * KEY_SHOWERRORS;
extern char const * KEY_SHOWINPLUGINMENU;
extern char const * KEY_SHOWINDISKMENU;
extern char const * KEY_SHOWTEMPNAMESASHIDEFILES;
extern char const * KEY_USEHIGHLIGHT;
extern char const * KEY_AUTOCOMPLITE;

extern DWORD g_ShowErrors;				
extern DWORD g_ShowInPluginMenu;		
extern DWORD g_ShowInDiskMenu;			
extern DWORD g_ShowTemporaryNamesAsHideFiles;
extern DWORD g_UseHighlighting;
extern DWORD g_AutoComplite;		


/* */
void* alloc_malloc(size_t size);
void alloc_free(void* p);
void* realloc(void* p, size_t size);

extern struct PluginStartupInfo g_PluginInfo; 
extern struct FarStandardFunctions g_FSF;

inline const char *GetMsg(int MsgId) {return g_PluginInfo.GetMsg(g_PluginInfo.ModuleNumber, MsgId);}

#ifdef _DEBUG
#define TRACE(X) OutputDebugString(X); OutputDebugString("\n");
#else
#define TRACE(X)
#endif

#endif // !defined(AFX_COMMON_H__5693E527_B98A_4F45_8134_2C926705181A__INCLUDED_)
