#include <windows.h>
#include <plugin.hpp>
#include <mp3msg.h>
#include <mp3misc.h>
#include <mp3reg.h>
#include <mp3dlg.h>
#include <mp3tag.h>

#define MAX_DLG_LEN COMMENT_SIZE

#define EDIT_TEXT_TITLE 1
#define EDIT_TEXT_ARTIST 3
#define EDIT_TEXT_ALBUM 5
#define EDIT_TEXT_YEAR 7
#define EDIT_TEXT_STYLE 9
#define EDIT_TEXT_COMM 11
#define EDIT_EDIT_TITLE 2
#define EDIT_EDIT_ARTIST 4
#define EDIT_EDIT_ALBUM 6
#define EDIT_EDIT_YEAR  8
#define EDIT_EDIT_STYLE  10
#define EDIT_EDIT_COMM  12
#define EDIT_BUTTON_OK 14
#define EDIT_BUTTON_SKIP 15
#define EDIT_BUTTON_UNTAG 16
#define EDIT_BUTTON_CANCEL 17
#define EDIT_MAX_TEXT 9

#define DESC_TEXT_CAPTION 0
#define DESC_TEXT_FILE 1
#define DESC_TEXT_MP3NFO 3
#define DESC_TEXT_MP3NONFO 5
#define DESC_EDIT_FILE 2
#define DESC_EDIT_TEMPLATE 4
#define DESC_EDIT_TEMPLATENOTAG 6
#define DESC_BUTTON_OK 8
#define DESC_BUTTON_CANCEL 9
#define DESC_MAX_TEXT 11

#define TGFN_TEXT_TITLE 0
#define TGFN_TEXT_TEMPL 1
#define TGFN_EDIT_TEMPL 2
#define TGFN_BUTTON_TAG 4
#define TGFN_BUTTON_FNAME 5
#define TGFN_BUTTON_CANCEL 6

#define CFG_TEXT_CAPTION 0
#define CFG_EMPTY_TAG 1
#define CFG_FULL_MATCH 2
#define CFG_UPDATE_TAG 3
#define CFG_BUTTON_OK 5
#define CFG_BUTTON_CANCEL 6

static FarDialogItem EditMP3DlgItems[] =
{
     { DI_DOUBLEBOX,3,1,45,10,0,0,0,0 },

     { DI_TEXT,5,2,0,0,0,0,DIF_BOXCOLOR,0 },
     { DI_FIXEDIT,13,2,42,0,TRUE,(int)"MP3_Title",DIF_HISTORY,0 },

     { DI_TEXT,5,3,0,0,0,0,DIF_BOXCOLOR,0 },
     { DI_FIXEDIT,13,3,42,0,0,(int)"MP3_Artist",DIF_HISTORY,0 },

     { DI_TEXT,5,4,0,0,0,0,DIF_BOXCOLOR,0 },
     { DI_FIXEDIT,13,4,42,0,0,(int)"MP3_Album",DIF_HISTORY,0 },

     { DI_TEXT,5,5,0,0,0,0,DIF_BOXCOLOR,0 },
     { DI_EDIT,13,5,42,0,0,(int)"MP3_Year",DIF_HISTORY,0 },

     { DI_TEXT,5,6,0,0,0,0,DIF_BOXCOLOR,0 },
     { DI_EDIT,13,6,42,0,0,(int)StyleEditHistory,DIF_HISTORY,0 },

     { DI_TEXT,5,7,0,0,0,0,DIF_BOXCOLOR,0 },
     { DI_FIXEDIT,13,7,42,0,0,(int)"MP3_Comment",DIF_HISTORY,0 },

     { DI_TEXT,0,8,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0 },

     { DI_BUTTON,0,9,0,0,0,0,DIF_CENTERGROUP,TRUE },
     { DI_BUTTON,0,9,0,0,0,0,DIF_CENTERGROUP,0 },
     { DI_BUTTON,0,9,0,0,0,0,DIF_CENTERGROUP,0 },
     { DI_BUTTON,0,9,0,0,0,0,DIF_CENTERGROUP,0 }
};

static FarDialogItem DescMP3DlgItems[] =
{
     { DI_DOUBLEBOX,3,1,46,7,0,0,0,0 },

     { DI_TEXT,5,2,0,0,0,0,DIF_BOXCOLOR,0 },
     { DI_EDIT,14,2,43,0,TRUE,(int)"MP3_Filelist",DIF_HISTORY,0 },

     { DI_TEXT,5,3,0,0,0,0,DIF_BOXCOLOR,0 },
     { DI_EDIT,14,3,43,0,0,(int)"MP3_TemplateHasTag",DIF_HISTORY,0 },

     { DI_TEXT,5,4,0,0,0,0,DIF_BOXCOLOR,0 },
     { DI_EDIT,14,4,43,0,0,(int)"MP3_TemplateHasNotTag",DIF_HISTORY,0 },

     { DI_TEXT,0,5,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0 },

     { DI_BUTTON,0,6,0,0,0,0,DIF_CENTERGROUP,TRUE },
     { DI_BUTTON,0,6,0,0,0,0,DIF_CENTERGROUP,0 }
};

static FarDialogItem MP3TagToFromFilenameDlgItems[] =
{
     { DI_DOUBLEBOX,3,1,46,5,0,0,0,0 },

     { DI_TEXT,5,2,0,0,0,0,DIF_BOXCOLOR,0 },
     { DI_EDIT,14,2,43,0,TRUE,(int)"MP3_TemplateTagFilename",DIF_HISTORY,0 },

     { DI_TEXT,0,3,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0 },

     { DI_BUTTON,0,4,0,0,0,0,DIF_CENTERGROUP,TRUE },
     { DI_BUTTON,0,4,0,0,0,0,DIF_CENTERGROUP,0 },
     { DI_BUTTON,0,4,0,0,0,0,DIF_CENTERGROUP,0 }
};

static FarDialogItem CfgMP3DlgItems[] =
{
     { DI_DOUBLEBOX,3,1,45,7,0,0,0,0 },

     { DI_CHECKBOX,5,2,0,0,0,0,0,0 },
     { DI_CHECKBOX,5,3,0,0,0,0,0,0 },
     { DI_CHECKBOX,5,4,0,0,0,0,0,0 },

     { DI_TEXT,0,5,0,0,0,0,DIF_BOXCOLOR|DIF_SEPARATOR,0 },

     { DI_BUTTON,0,6,0,0,0,0,DIF_CENTERGROUP,TRUE },
     { DI_BUTTON,0,6,0,0,0,0,DIF_CENTERGROUP,0 }
};

/*****************************************************************************
     EDIT MP3 DIALOG
*****************************************************************************/

tEditMP3Dlg::tEditMP3Dlg()
{
     for ( int idx = 0; idx < ItemsCount(); idx++ )
     {
          EditMP3DlgItems[idx]. Focus = FALSE;
     }
     EditMP3DlgItems[EDIT_EDIT_TITLE]. Focus = TRUE;
     strncpyz( EditMP3DlgItems[EDIT_TEXT_TITLE]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MTitle ), EDIT_MAX_TEXT );
     strncpyz( EditMP3DlgItems[EDIT_TEXT_ARTIST]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MArtist ), EDIT_MAX_TEXT );
     strncpyz( EditMP3DlgItems[EDIT_TEXT_ALBUM]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MAlbum ), EDIT_MAX_TEXT );
     strncpyz( EditMP3DlgItems[EDIT_TEXT_YEAR]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MYear ), EDIT_MAX_TEXT );
     strncpyz( EditMP3DlgItems[EDIT_TEXT_STYLE]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MStyle ), EDIT_MAX_TEXT );
     strncpyz( EditMP3DlgItems[EDIT_TEXT_COMM]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MComment ), EDIT_MAX_TEXT );
     strcpy( EditMP3DlgItems[EDIT_BUTTON_OK]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MOk ) );
     strcpy( EditMP3DlgItems[EDIT_BUTTON_SKIP]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MSkip ) );
     strcpy( EditMP3DlgItems[EDIT_BUTTON_UNTAG]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MUntag ) );
     strcpy( EditMP3DlgItems[EDIT_BUTTON_CANCEL]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MCancel ) );
}

FarDialogItem* tEditMP3Dlg::Items() const
{
     return EditMP3DlgItems;
}

int tEditMP3Dlg::ItemsCount() const
{
     return sizeof( EditMP3DlgItems ) / sizeof( EditMP3DlgItems[0] );
}

FarDialogItem* tEditMP3Dlg::ReadMP3tagZ( const tMP3tagZ *tagZ, BOOL bInitPrev ) const
{
     if ( MP3tagZ( tagZ ) )
     {
          strncpyz( EditMP3DlgItems[EDIT_EDIT_TITLE]. Data, tagZ -> title, sizeof( EditMP3DlgItems[EDIT_EDIT_TITLE]. Data ) );
          strncpyz( EditMP3DlgItems[EDIT_EDIT_ARTIST]. Data, tagZ -> artist, sizeof( EditMP3DlgItems[EDIT_EDIT_ARTIST]. Data ) );
          strncpyz( EditMP3DlgItems[EDIT_EDIT_ALBUM]. Data, tagZ -> album, sizeof( EditMP3DlgItems[EDIT_EDIT_ALBUM]. Data ) );
          strncpyz( EditMP3DlgItems[EDIT_EDIT_YEAR]. Data, tagZ -> year, sizeof( EditMP3DlgItems[EDIT_EDIT_YEAR]. Data ) );
          strncpyz( EditMP3DlgItems[EDIT_EDIT_COMM]. Data, tagZ -> comment, sizeof( EditMP3DlgItems[EDIT_EDIT_COMM]. Data ) );
          if ( !RegQueryStyle(
               FarRootKey,
               MP3StylesSubKey,
               tagZ -> style,
               EditMP3DlgItems[EDIT_EDIT_STYLE]. Data,
               sizeof( EditMP3DlgItems[EDIT_EDIT_STYLE]. Data ) ) )
          {
               itoa( tagZ -> style, EditMP3DlgItems[EDIT_EDIT_STYLE]. Data, 10 );
          }
     }
     else
     {
          if ( bInitPrev == FALSE )
          {
               EditMP3DlgItems[EDIT_EDIT_ARTIST]. Data[0] = 0;
               EditMP3DlgItems[EDIT_EDIT_ALBUM]. Data[0] = 0;
               EditMP3DlgItems[EDIT_EDIT_YEAR]. Data[0] = 0;
               EditMP3DlgItems[EDIT_EDIT_COMM]. Data[0] = 0;
               EditMP3DlgItems[EDIT_EDIT_STYLE]. Data[0] = 0;
          }

          EditMP3DlgItems[EDIT_EDIT_TITLE]. Data[0] = 0;
     }

     return EditMP3DlgItems;
}

tMP3tagZ* tEditMP3Dlg::WriteMP3tagZ( tMP3tagZ *tagZ ) const
{
     strncpyz( tagZ -> title, EditMP3DlgItems[EDIT_EDIT_TITLE]. Data, sizeof( tagZ -> title ) );
     strncpyz( tagZ -> artist, EditMP3DlgItems[EDIT_EDIT_ARTIST]. Data, sizeof( tagZ -> artist ) );
     strncpyz( tagZ -> album, EditMP3DlgItems[EDIT_EDIT_ALBUM]. Data, sizeof( tagZ -> album ) );
     strncpyz( tagZ -> year, EditMP3DlgItems[EDIT_EDIT_YEAR]. Data, sizeof( tagZ -> year ) );
     strncpyz( tagZ -> comment, EditMP3DlgItems[EDIT_EDIT_COMM]. Data, sizeof( tagZ -> comment ) );
     if ( !RegQueryStyleCode(
          FarRootKey,
          MP3StylesSubKey,
          EditMP3DlgItems[EDIT_EDIT_STYLE]. Data,
          &( tagZ -> style ) ) )
     {
          tagZ -> style = ( BYTE ) atoi ( EditMP3DlgItems[EDIT_EDIT_STYLE]. Data );
     }

     return tagZ;
}

const char *tEditMP3Dlg::SetCaption( const char *Caption ) const
{
     return strncpyz(
          EditMP3DlgItems[0]. Data,
          Caption,
          sizeof( EditMP3DlgItems[0]. Data )
     );
}

int tEditMP3Dlg::Ok() const
{
     return EDIT_BUTTON_OK;
}

int tEditMP3Dlg::Skip() const
{
     return EDIT_BUTTON_SKIP;
}

int tEditMP3Dlg::Untag() const
{
     return EDIT_BUTTON_UNTAG;
}

int tEditMP3Dlg::Cancel() const
{
     return EDIT_BUTTON_CANCEL;
}

BOOL tEditMP3Dlg::DataEntered() const
{
     return
          EditMP3DlgItems[EDIT_EDIT_TITLE]. Data[0] ||
          EditMP3DlgItems[EDIT_EDIT_ARTIST]. Data[0] ||
          EditMP3DlgItems[EDIT_EDIT_ALBUM]. Data[0] ||
          EditMP3DlgItems[EDIT_EDIT_YEAR]. Data[0] ||
          EditMP3DlgItems[EDIT_EDIT_STYLE]. Data[0] ||
          EditMP3DlgItems[EDIT_EDIT_COMM]. Data[0];
}

BOOL tEditMP3Dlg::ValidDate() const
{
     return ValidDecimal( EditMP3DlgItems[EDIT_EDIT_YEAR]. Data, 4 );
}

BOOL tEditMP3Dlg::ValidStyle() const
{
     BOOL bReturn;

     bReturn = RegQueryStyle(
          FarRootKey,
          MP3StylesSubKey,
          EditMP3DlgItems[EDIT_EDIT_STYLE]. Data
     );
     if ( !bReturn )
     {
          bReturn = ValidDecimal( EditMP3DlgItems[EDIT_EDIT_STYLE]. Data, 3 );
     }

     return bReturn;
}

/*****************************************************************************
     DESCRIBE MP3 DIALOG
*****************************************************************************/

tDescMP3Dlg::tDescMP3Dlg()
{
     strcpy( DescMP3DlgItems[DESC_TEXT_CAPTION]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MDescription ) );
     strncpyz( DescMP3DlgItems[DESC_TEXT_FILE]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MFilename ), DESC_MAX_TEXT );
     strncpyz( DescMP3DlgItems[DESC_TEXT_MP3NFO]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MTemplate ), DESC_MAX_TEXT );
     strncpyz( DescMP3DlgItems[DESC_TEXT_MP3NONFO]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MTemplateNoTag ), DESC_MAX_TEXT );
     strcpy( DescMP3DlgItems[DESC_BUTTON_OK]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MOk ) );
     strcpy( DescMP3DlgItems[DESC_BUTTON_CANCEL]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MCancel ) );
}

FarDialogItem* tDescMP3Dlg::Items() const
{
     return DescMP3DlgItems;
}

int tDescMP3Dlg::ItemsCount() const
{
     return sizeof( DescMP3DlgItems ) / sizeof( DescMP3DlgItems[0] );
}

const char* tDescMP3Dlg::FileName() const
{
     return DescMP3DlgItems[DESC_EDIT_FILE]. Data;
}

const char* tDescMP3Dlg::Template() const
{
     return DescMP3DlgItems[DESC_EDIT_TEMPLATE]. Data;
}

const char* tDescMP3Dlg::TemplateNoTag() const
{
     return DescMP3DlgItems[DESC_EDIT_TEMPLATENOTAG]. Data;
}

int tDescMP3Dlg::Cancel() const
{
     return DESC_BUTTON_CANCEL;
}

BOOL tDescMP3Dlg::DataEntered() const
{
     return FileName()[0];
}

/*****************************************************************************
     FILENAME <-> MP3-TAG DIALOG
*****************************************************************************/

tMP3TagToFromFilenameDlg::tMP3TagToFromFilenameDlg()
{
     for ( int idx = 0; idx < ItemsCount(); idx++ )
     {
          MP3TagToFromFilenameDlgItems[idx]. Focus = FALSE;
     }
     MP3TagToFromFilenameDlgItems[TGFN_EDIT_TEMPL]. Focus = TRUE;

     strcpy( MP3TagToFromFilenameDlgItems[TGFN_TEXT_TITLE]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MTagFilename ) );
     strcpy( MP3TagToFromFilenameDlgItems[TGFN_TEXT_TEMPL]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MTgFnTemplate ) );
     strcpy( MP3TagToFromFilenameDlgItems[TGFN_BUTTON_TAG]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MToTag ) );
     strcpy( MP3TagToFromFilenameDlgItems[TGFN_BUTTON_FNAME]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MToFilename ) );
     strcpy( MP3TagToFromFilenameDlgItems[TGFN_BUTTON_CANCEL]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MCancel ) );
}

struct FarDialogItem* tMP3TagToFromFilenameDlg::Items() const
{
     return MP3TagToFromFilenameDlgItems;
}

int tMP3TagToFromFilenameDlg::ItemsCount() const
{
     return sizeof( MP3TagToFromFilenameDlgItems ) / sizeof( MP3TagToFromFilenameDlgItems[0] );
}

const char* tMP3TagToFromFilenameDlg::Template() const
{
     return MP3TagToFromFilenameDlgItems[TGFN_EDIT_TEMPL]. Data;
}

int tMP3TagToFromFilenameDlg::Tag() const
{
     return TGFN_BUTTON_TAG;
}

int tMP3TagToFromFilenameDlg::Filename() const
{
     return TGFN_BUTTON_FNAME;
}

int tMP3TagToFromFilenameDlg::Cancel() const
{
     return TGFN_BUTTON_CANCEL;
}

BOOL tMP3TagToFromFilenameDlg::DataEntered() const
{
     return MP3TagToFromFilenameDlgItems[TGFN_EDIT_TEMPL]. Data[0];
}

/*****************************************************************************
     CONFIGURE MP3 DIALOG
*****************************************************************************/

tCfgMP3Dlg::tCfgMP3Dlg()
{
     strcpy( CfgMP3DlgItems[CFG_TEXT_CAPTION]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MPluginConfig ) );

     strcpy( CfgMP3DlgItems[CFG_EMPTY_TAG]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MCfgFillEmptyTag ) );
     strcpy( CfgMP3DlgItems[CFG_FULL_MATCH]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MCfgFullTemplMatch ) );
     strcpy( CfgMP3DlgItems[CFG_UPDATE_TAG]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MCfgUpdateTag ) );

     strcpy( CfgMP3DlgItems[CFG_BUTTON_OK]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MOk ) );
     strcpy( CfgMP3DlgItems[CFG_BUTTON_CANCEL]. Data, GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MCancel ) );
}

struct FarDialogItem* tCfgMP3Dlg::Items() const
{
     return CfgMP3DlgItems;
}

int tCfgMP3Dlg::ItemsCount() const
{
     return sizeof( CfgMP3DlgItems ) / sizeof( CfgMP3DlgItems[0] );
}

int tCfgMP3Dlg::Ok() const
{
     return CFG_BUTTON_OK;
}

void tCfgMP3Dlg::Set( DWORD dwFlags )
{
     CfgMP3DlgItems[CFG_EMPTY_TAG]. Selected = dwFlags & FL_FILL_EMPTY;
     CfgMP3DlgItems[CFG_FULL_MATCH]. Selected = dwFlags & FL_FULL_MATCH;
     CfgMP3DlgItems[CFG_UPDATE_TAG]. Selected = dwFlags & FL_UPDATE_TAG;
}

DWORD tCfgMP3Dlg::Get() const
{
     DWORD dwResult = 0;

     if ( CfgMP3DlgItems[CFG_EMPTY_TAG]. Selected )
     {
          dwResult |= FL_FILL_EMPTY;
     }
     if ( CfgMP3DlgItems[CFG_FULL_MATCH]. Selected )
     {
          dwResult |= FL_FULL_MATCH;
     }
     if ( CfgMP3DlgItems[CFG_UPDATE_TAG]. Selected )
     {
          dwResult |= FL_UPDATE_TAG;
     }

     return dwResult;
}


