#include <windows.h>
#include <plugin.hpp>
#include <mp3tag.h>
#include <mp3msg.h>
#include <mp3misc.h>
#include <string.h>

TCHAR Mp3Ext[] = { '.', 'm', 'p', '3' };
TCHAR Zero = 0;

/*************************************************************************
 Function:     strncpyz
 Description:     dest_size - 1   ப src 
                dest  㤠 ஡   ப dest
 Return:       dest
 Comments:     dest ᥣ 蠥 ᨬ 0
 *************************************************************************/

char *strncpyz( char *dest, const char *src, int dest_size )
{
     strncpy( dest, src, dest_size );
     dest[dest_size - 1] = 0;
     for (
          int __i = strlen( dest ) - 1;
          ( __i >= 0 ) && ( dest[__i] == ' ' );
          __i-- )
     {
        dest[__i] = 0;
     }

     return dest;
}

LPCTSTR GetFarRootKey( LPTSTR lpszDest, LPCTSTR lpcszSrc )
{
     int idx;

     for ( idx = strlen( lpcszSrc ); idx && lpcszSrc[idx] != '\\'; idx-- );
     strncpyz( lpszDest, lpcszSrc, idx + 1 );

     return ( LPCTSTR ) lpszDest;
}

/*************************************************************************
 Function:     Message
 Description:  뢮 ᮮ饭
 Parameters:
     Flags       ᮮ饭
     lpcszTitle  ᮮ饭
     lpcszMessage  ᮮ饭
 Return:
 Comments:
 *************************************************************************/

VOID Message(
     int Flags,
     LPCTSTR lpcszTitle,
     LPCTSTR lpcszMessage )
{
     const char *Items[] =
     {
          lpcszTitle,
          lpcszMessage,
          "\1",
          GetPSI() -> GetMsg( GetPSI() -> ModuleNumber, MOk )
     };

     GetPSI() -> Message(
          GetPSI() -> ModuleNumber,
          Flags,
          NULL,
          ( char** ) Items,
          sizeof( Items ) / sizeof( Items[0] ),
          1
     );
}

/*************************************************************************
 Function:     PanelItemsSelected
 Description:  ஢ 뤥  䠩  
 Parameters:
     lpPanelInfo ⥫  , 뢠  FAR'
 Return:
     TRUE       뤥
     FALSE       뤥
 Comments:
 *************************************************************************/

BOOL PanelItemsSelected( PanelInfo *lpPanelInfo )
{
     BOOL bResult = FALSE;

     for ( int idx = 0; idx < lpPanelInfo -> ItemsNumber; idx++ )
     {
          if ( lpPanelInfo -> PanelItems[idx]. Flags & PPIF_SELECTED )
          {
               bResult = TRUE;
               break;
          }
     }

     return bResult;
}

/*************************************************************************
 Function:     ValidMp3Ext
 Description:  ஢ ७ 䠩
 Parameters:
     FileName   䠩
 Return:
     TRUE        ࠢ쭮 ७
     FALSE       ࠢ쭮 ७
 Comments:
 *************************************************************************/

BOOL ValidMp3Ext( LPCTSTR FileName )
{
     BOOL bResult = TRUE;

     if ( strnicmp(
          FileName + strlen( FileName ) - sizeof( Mp3Ext ),
          Mp3Ext,
          sizeof( Mp3Ext ) ) )
     {
          bResult = FALSE;
     }

     return bResult;
}

/*************************************************************************
 Function:     ValidDecimal
 Description:  ஢, ⮨  ப   ⢠
                
 Parameters:
     lpcsz     ப
     dwMaxLen  ᨬ쭮 ⢮  
 Return:
     TRUE      ப ⮨ bp  , 祬 dwMaxLen  
     FALSE     ப ᮤন ᨬ  , 祬 dwMaxLen
 Comments:
 *************************************************************************/

BOOL ValidDecimal( LPCTSTR lpcsz, DWORD dwMaxLen )
{
     BOOL bResult = TRUE;
     int idx;

     for ( idx = 0; lpcsz[idx]; idx++ )
     {
          if ( ( lpcsz[idx] < '0' ) || ( lpcsz[idx] > '9' ) )
          {
               bResult = FALSE;
               break;
          }
     }

     return bResult && ( idx <= dwMaxLen );
}

